open Graphics

let background res w h =
  set_color (rgb 0x00 0x00 0x00) ;
  fill_rect 0 0 (res * w) (res * h)

let empty x y w h =
  let d = 2 in
  set_color (rgb 0x66 0x33 0x00) ;
  fill_rect (x + d) y (w - 2 * d) (h / 3 - 2 * d) ;
  fill_rect (x + d) (y + 2 * h / 3) (w - 2 * d) (h / 3 - 2 * d) ;
  fill_rect x (y + h / 3) (w / 2 - d) (h / 3 - 2 * d) ;
  fill_rect (x + w / 2 + d) (y + h / 3) (w / 2 - d) (h / 3 - 2 * d)

let wall x y w h =
  let d = 2 in
  set_color (rgb 0xCC 0x66 0x33) ;
  fill_rect (x + d) y (w - 2 * d) (h / 3 - 2 * d) ;
  fill_rect (x + d) (y + 2 * h / 3) (w - 2 * d) (h / 3 - 2 * d) ;
  fill_rect x (y + h / 3) (w / 2 - d) (h / 3 - 2 * d) ;
  fill_rect (x + w / 2 + d) (y + h / 3) (w / 2 - d) (h / 3 - 2 * d)

let lambda_man x y w h =
  empty x y w h ;
  let d = w / 5 in
  set_line_width d ;
  set_color (rgb 0xFF 0xFF 0x88) ;
  moveto (x + d) (y + d) ;
  lineto (x + w / 2) (y + h / 2) ;
  moveto (x + w - d) (y + d) ;
  lineto (x + d) (y + h - d)

let pill x y w h =
  empty x y w h ;
  set_color (rgb 0xCC 0xCC 0x55) ;
  fill_ellipse (x + w / 2) (y + w / 2) (w * 2 / 8) (h * 2 / 8)

let power_pill x y w h =
  empty x y w h ;
  set_color (rgb 0xFF 0xFF 0xEE) ;
  fill_ellipse (x + w / 2) (y + w / 2) (w * 2 / 8) (h * 2 / 8)

let ghost x y w h =
  empty x y w h ;
  set_color (rgb 0x88 0x88 0x88) ;
  fill_ellipse (x + w / 2) (y + w / 2) (w / 4) (h / 4) ;
  fill_rect (x + w / 4) (y + w / 4) (w / 2) (h / 4) ;
  set_color (rgb 0x00 0x00 0x00) ;
  fill_ellipse (x + w / 2 + w / 10) (y + w / 2) (w / 15) (h / 15) ;
  fill_ellipse (x + w / 2 - w / 10) (y + w / 2) (w / 15) (h / 15)
  
let fruit x y w h =
  empty x y w h ;
  set_color (rgb 0xDD 0x00 0x00) ;
  fill_ellipse (x + w / 2) (y + w / 2) (w * 3 / 8) (h * 3 / 8)

let font = [|
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (*   *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* ! *) ;
  0b0_0_0_0__1_0_0_0__1_0_0_0__0_0_0_0 (* '"' *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* # *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* $ *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* % *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_0 (* & *) ;
  0b0_0_0_0__1_0_0_0__0_0_0_0__0_0_0_0 (* ' *) ;
  0b0_0_0_1__1_0_0_0__0_0_0_0__0_0_0_0 (* ( *) ;
  0b0_0_1_0__0_1_0_0__0_0_0_0__0_0_0_0 (* ) *) ;
  0b0_0_1_1__1_1_1_1__1_1_0_0__0_0_0_0 (* * *) ;
  0b0_0_0_0__0_0_1_1__1_1_0_0__0_0_0_0 (* + *) ;
  0b0_0_1_0__0_0_0_0__0_0_0_0__0_0_0_0 (* , *) ;
  0b0_0_0_0__0_0_1_1__0_0_0_0__0_0_0_0 (* - *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_1 (* . *) ;
  0b0_0_1_0__1_0_0_0__0_0_0_0__0_0_0_0 (* / *) ;
  0b0_0_1_0__1_0_0_0__0_0_1_1__1_1_1_1 (* 0 *) ;
  0b0_0_0_0__1_0_0_0__0_0_1_1__0_0_0_0 (* 1 *) ;
  0b0_0_1_0__1_0_0_0__0_0_0_0__1_0_1_1 (* 2 *) ;
  0b0_0_0_1__1_0_0_1__0_0_0_0__0_0_1_1 (* 3 *) ;
  0b0_0_0_0__0_0_1_1__1_1_0_0__1_0_0_0 (* 4 *) ;
  0b0_0_0_0__0_0_1_1__0_0_0_0__1_0_1_1 (* 5 *) ;
  0b0_0_0_0__0_0_1_1__0_0_0_1__1_1_1_1 (* 6 *) ;
  0b0_0_1_0__1_0_1_1__0_0_0_0__0_0_1_0 (* 7 *) ;
  0b0_0_0_0__0_0_1_1__0_0_1_1__1_1_1_1 (* 8 *) ;
  0b0_0_0_0__0_0_1_1__0_0_1_1__1_0_1_1 (* 9 *) ;
  0b0_0_0_0__0_0_0_0__1_1_0_0__0_0_0_0 (* : *) ;
  0b0_0_1_0__0_0_0_0__1_0_0_0__0_0_0_0 (* ; *) ;
  0b0_0_0_1__1_0_0_0__0_0_0_0__0_0_0_0 (* < *) ;
  0b0_0_0_0__0_0_1_1__0_0_0_0__0_0_0_1 (* = *) ;
  0b0_0_1_0__0_1_0_0__0_0_0_0__0_0_0_0 (* > *) ;
  0b0_0_0_0__1_0_0_0__0_1_0_0__1_0_1_0 (* ? *) ;
  0b0_0_0_0__0_0_1_0__0_0_1_0__1_1_1_1 (* @ *) ;
  0b0_0_0_0__0_0_1_1__0_0_1_1__1_1_1_0 (* A *) ;
  0b0_0_1_0__0_1_1_0__0_0_1_1__0_0_1_1 (* B *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__1_1_1_1 (* C *) ;
  0b0_0_1_0__0_1_0_0__0_0_1_1__0_0_1_1 (* D *) ;
  0b0_0_0_0__0_0_1_1__0_0_0_0__1_1_1_1 (* E *) ;
  0b0_0_0_0__0_0_1_1__0_0_0_0__1_1_1_0 (* F *) ;
  0b0_0_0_0__0_0_1_0__0_0_0_1__1_1_1_1 (* G *) ;
  0b0_0_0_0__0_0_1_1__0_0_1_1__1_1_0_0 (* H *) ;
  0b0_0_0_0__0_0_0_0__1_1_0_0__0_0_0_0 (* I *) ;
  0b0_0_0_0__0_0_0_0__0_0_1_1__0_1_0_1 (* J *) ;
  0b0_0_0_1__1_0_0_1__0_0_0_0__1_1_0_0 (* K *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__1_1_0_1 (* L *) ;
  0b0_0_0_0__1_1_0_0__0_0_1_1__1_1_0_0 (* M *) ;
  0b0_0_0_1__0_1_0_0__0_0_1_1__1_1_0_0 (* N *) ;
  0b0_0_0_0__0_0_0_0__0_0_1_1__1_1_1_1 (* O *) ;
  0b0_0_0_0__0_0_1_1__0_0_1_0__1_1_1_0 (* P *) ;
  0b0_0_0_1__0_0_0_0__0_0_1_1__1_1_1_1 (* Q *) ;
  0b0_0_0_1__0_0_1_1__0_0_1_0__1_1_1_0 (* R *) ;
  0b0_0_0_0__0_0_1_1__0_0_0_1__1_0_1_1 (* S *) ;
  0b0_0_0_0__0_0_0_0__1_1_0_0__0_0_1_0 (* T *) ;
  0b0_0_0_0__0_0_0_0__0_0_1_1__1_1_0_1 (* U *) ;
  0b0_0_1_0__1_0_0_0__0_0_0_0__1_1_0_0 (* V *) ;
  0b0_0_1_1__0_0_0_0__0_0_1_1__1_1_0_0 (* W *) ;
  0b0_0_1_1__1_1_0_0__0_0_0_0__0_0_0_0 (* X *) ;
  0b0_0_0_0__1_1_0_0__0_1_0_0__0_0_0_0 (* Y *) ;
  0b0_0_1_0__1_0_0_0__0_0_0_0__0_0_1_1 (* Z *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__1_1_1_1 (* [ *) ;
  0b0_0_0_1__0_1_0_0__0_0_0_0__0_0_0_0 (* \ *) ;
  0b0_0_0_0__0_0_0_0__0_0_1_1__1_1_0_0 (* ] *) ;
  0b0_0_0_0__0_1_0_0__0_0_0_0__1_0_0_0 (* ^ *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_0__0_0_0_1 (* _ *) ;
  0b0_0_0_0__0_1_0_0__0_0_0_0__0_0_0_0 (* ` *) ;
  0b0_0_0_0__0_0_1_1__0_0_1_1__0_1_1_1 (* a *) ;
  0b0_0_0_0__0_0_1_1__0_0_0_1__1_1_0_1 (* b *) ;
  0b0_0_0_0__0_0_1_1__0_0_0_0__0_1_0_1 (* c *) ;
  0b0_0_0_0__0_0_1_1__0_0_1_1__0_1_0_1 (* d *) ;
  0b0_0_0_0__0_0_1_1__0_0_1_0__1_1_1_1 (* e *) ;
  0b0_0_0_0__0_0_0_1__0_0_0_0__1_1_1_0 (* f *) ;
  0b0_0_0_0__0_0_1_1__0_0_1_1__1_0_1_1 (* g *) ;
  0b0_0_0_0__0_0_1_1__0_0_0_1__1_1_0_0 (* h *) ;
  0b0_0_0_0__0_0_0_0__0_1_0_0__0_0_0_0 (* i *) ;
  0b0_0_1_0__0_0_0_0__1_0_0_0__0_0_0_0 (* j *) ;
  0b0_0_0_1__0_0_1_1__0_0_0_0__1_1_0_0 (* k *) ;
  0b0_0_0_0__0_0_0_0__1_1_0_0__0_0_0_0 (* l *) ;
  0b0_0_0_0__0_0_1_1__0_1_0_1__0_1_0_0 (* m *) ;
  0b0_0_0_0__0_0_0_1__0_1_0_0__0_1_0_0 (* n *) ;
  0b0_0_0_0__0_0_1_1__0_0_0_1__0_1_0_1 (* o *) ;
  0b0_0_0_0__1_0_0_1__0_0_0_0__1_1_1_0 (* p *) ;
  0b0_0_0_0__1_1_0_0__0_0_1_1__0_0_1_0 (* q *) ;
  0b0_0_0_0__0_0_0_1__0_0_0_0__0_1_0_0 (* r *) ;
  0b0_0_1_0__0_1_0_0__0_0_1_0__0_1_1_0 (* s *) ;
  0b0_0_0_0__0_0_0_1__0_0_0_0__1_1_0_1 (* t *) ;
  0b0_0_0_0__0_0_0_0__0_0_0_1__0_1_0_1 (* u *) ;
  0b0_0_1_0__0_0_0_0__0_0_0_0__0_1_0_0 (* v *) ;
  0b0_0_1_1__0_0_0_0__0_0_0_1__0_1_0_0 (* w *) ;
  0b0_0_1_0__1_0_0_1__1_0_0_0__0_0_0_0 (* x *) ;
  0b0_0_0_0__0_1_0_1__0_0_1_1__0_0_0_1 (* y *) ;
  0b0_0_1_0__0_0_0_1__0_0_0_0__0_0_0_1 (* z *) ;
  0b0_0_0_1__1_0_0_1__0_0_0_0__0_0_0_0 (* { *) ;
  0b0_0_0_0__0_0_0_1__1_0_0_0__0_0_0_0 (* | *) ;
  0b0_0_1_0__0_1_1_0__0_0_0_0__0_0_0_0 (* } *) ;
  0b0_0_0_0__0_1_0_0__1_0_0_0__1_0_0_0 (* ~ *) ;
  0b0_0_0_0__0_0_1_0__0_0_0_0__0_0_0_0 (* - *) ;
|]

let draw_text text x y w h =
  let sep = w / 8 in
  let w = w - sep in
  set_color @@ rgb 0xFF 0xDD 0xAA ;
  set_line_width (w / 8) ;
  let d = w / 8 in
  let d2 = w / 8 in
  let segs = [|
    d2, d, w - d2, d ;
    d2, h - d, w - d2, h - d ;
    d, d2, d, h / 2 - d ;
    d, h / 2 + d, d, h - d2 ;
    w - d, d2, w - d, h / 2 - d ;
    w - d, h / 2 + d, w - d, h - d2 ;
    w / 2, d2, w / 2, h / 2 - d ;
    w / 2, h / 2 + d, w / 2, h - d2 ;
    d2, h / 2, w / 2 - d, h / 2 ;
    w / 2 + d, h / 2, w - d2, h / 2 ;
    d2, h - d2, w / 2 - d2, h / 2 + d2 ;
    w - d2, h - d2, w / 2 + d2, h / 2 + d2 ;
    w - d2, d2, w / 2 + d2, h / 2 - d2 ;
    d2, d2, w / 2 - d2, h / 2 - d2 ;
  |] in
  let draw_char c x y =
    for i = 0 to 14 do
      if (font.(c) lsr i) land 1 = 1 then
        let x1, y1, x2, y2 = segs.(i) in
        moveto (x + x1) (y + y1) ;
        lineto (x + x2) (y + y2)
    done
  in
  for i = 0 to String.length text - 1 do
    draw_char (Char.code text.[i]) (x + (w + sep) * i + sep / 2) y
  done
