
(* Run ONE instruction and only ONE

 *)
val run_ins : int GccTypes.state -> int GccTypes.state

(* function called when a DBUG instruction is found *)
(* val set_debug : ('a GccTypes.value -> unit) -> unit *)

val init_state : 'a GccTypes.program -> 'a GccTypes.state

type 'a closure = ('a * 'a GccTypes.frame)

val run_instrs :
  int GccTypes.program -> int closure ->
  int GccTypes.value array -> int GccTypes.value option

type 'a runner

type 'a info =
  | Val of 'a GccTypes.value
  | Error of string

type 'a debugger =
    'a runner -> 'a info -> 'a GccTypes.state ->
    string list -> 'a list -> unit

type 'a tracer =
    'a runner -> 'a GccTypes.state -> unit

val int_runner : int GccTypes.program -> int runner
val arg_runner :
  ?debug:(GccTypes.arg debugger) ->
  ?trace:(GccTypes.arg tracer) ->
  GccTypes.arg GccTypes.program -> GccTypes.arg runner

val instrs_runner : 'a runner -> 'a GccTypes.state -> 'a GccTypes.state

val init_state' : 'a runner -> 'a GccTypes.state

val run_instrs' :
  'a runner -> 'a closure ->
  'a GccTypes.value array -> 'a GccTypes.value option

val entry_point : 'a runner -> 'a

val simple_debug : Format.formatter -> GccTypes.arg debugger

val simple_trace : Format.formatter -> GccTypes.arg tracer

val print_value : GccTypes.arg runner ->
           Format.formatter -> GccTypes.arg GccTypes.value -> unit

val get_count : unit -> int
