
type cell =
  | Wall
  | Empty
  | Pill
  | PowerPill
  | Fruit
  | LambdaManStart
  | GhostStart

type row = cell list
type map = row list
type location = { x : int; y : int }

type direction = Up | Right | Down | Left

type lambda_man = {
  vitality : int; (* ticks before end of power pill activity *)
  position : int * int;
  direction : direction;
  lives : int;
  score : int;
}

type ghost_vitality =
  | Standard
  | Fright_mode
  | Invisible

type ghost =
    { vitality : ghost_vitality;
      location : location;
      direction : direction }
type fruit = int

type world = map * lambda_man * ghost array * fruit

type state

type value
external value : 'a -> value = "%identity"
external car : value -> value = "percent_car"
external cdr : value -> value = "percent_cdr"
external cons : value -> value -> value = "percent_cons"

type step_function = state -> value -> value

val main : value  -> value
