let array_of_map map =
  let amap = array_init 255 (fun _ -> array_create 255 Wall) in
  list_iteri
    (fun row y ->
       let arow = array_get amap y in
       list_iteri
         (fun cell x -> match cell with Wall -> () | cell -> array_set arow x cell)
         row)
    map ;
  amap

type state = direction

let ai_init world =
  (* (* DEBUG *)
  let amap = array_of_map world.map in
  let h = list_length world.map in
  let w = match world.map with [] -> 0 | l :: _ -> list_length l in  
  let get, get', set, swap = buffered_array false in
  list_iter
    (fun { location = { x ; y }} -> set x y true)
    world.ghosts  ;
  let propagate () =
    for y = 1 to h - 1 do
      for x = 1 to w - 1 do
        if (array_get2 amap x y <> Wall 
            && (get' x y
                || get' x (y + 1) || get' x (y - 1)
                || get' (x + 1) y || get' (x - 1) y)) then
          set x y true
      done
    done
  in
  swap () ; propagate () ;
  swap () ; propagate () ;
  for y = 0 to h - 1 do
    for x = 0 to w - 1 do
      if array_get2 amap x y = Wall then
        set x y true
    done
  done ;
  let map = ref (value 0) in
  for j = h - 1 downto 0 do
    let row = ref (value 0) in
    for i = w - 1 downto 0 do
      row := cons (value (get i j)) !row
    done ;
    map := cons !row !map
  done ;
  debug (cons (value 1664_1664) !map) ; *)
  Up

let ai_step world state =
  let amap = array_of_map world.map in
  let get, get', set, swap = buffered_array false in
  let h = list_length world.map in
  let w = match world.map with [] -> 0 | l :: _ -> list_length l in
  list_iter
    (fun { location = { x ; y }} -> set x y true)
    world.ghosts  ;
  let propagate () =
    for y = 1 to h - 1 do
      for x = 1 to w - 1 do
        if (array_get2 amap x y <> Wall 
            && (get' x y
                || get' x (y + 1)
                || get' x (y - 1)
                || get' (x + 1) y
                || get' (x - 1) y)) then
          set x y true
      done
    done
  in
  swap () ; propagate () ;
  swap () ; propagate () ;
  for y = 0 to h - 1 do
    for x = 0 to w - 1 do
      if array_get2 amap x y = Wall then
        set x y true
    done
  done ;
  let { x ; y } = world.lambda_man.location in
  let rec change avoid =
    let avail =
      (if not (get x (y - 1)) then [ Up ] else [])
      @ (if not (get x (y + 1)) then [ Down ] else [])
      @ (if not (get (x + 1) y) then [ Right ] else [])
      @ (if not (get (x - 1) y) then [ Left ] else [])
    in
    let avail = list_fold_left (fun r e -> if e = avoid then r else e :: r) [] avail in
    let rec rand = function
      | [ single ] -> single
      | hd :: tl -> if random_int_256 () < 128 then hd else rand tl
      | [] -> random ()
    in rand avail
  and random () =
    match random_int_256 () mod 4 with
    | 0 -> Up
    | 1 -> Left
    | 2 -> Right
    | _ -> Down
  (* and continue = function *)
    (* | Up -> if not (get x (y - 1)) then Up else change Down *)
    (* | Down -> if not (get x (y + 1)) then Down else change Up *)
    (* | Right -> if not (get (x + 1) y) then Right else change Left *)
    (* | Left -> if not (get (x - 1) y) then Left else change Right *)
  and choose = function
    | Up -> change Down
    | Down -> change Up
    | Right -> change Left
    | Left -> change Right
  in
  let state = choose state in
  state, state
