
type cell =
  | Empty
  | Wall
  | Pill
  | Power_pill
  | Fruit
  | Lambda_man
  | Ghost

type location = { x : int; y : int }

type direction = Up | Down | Left | Right

type lambda_man =
    { vitality : int;
      (** n = 0 : normal
          n > 0 : number of ticks with active power pill *)
      starting_location : location;
      location : location;
      direction : direction;
      remaining_lives : int;
      score : int }

type ghost_vitality =
  | Standard
  | Fright_mode
  | Invisible

type ghost =
    { vitality : ghost_vitality;
      current_location : location;
      starting_location : location;
      direction : direction }

type ghosts = ghost array

type world =
    { map : cell array array;
      lambda_man : lambda_man;
      ghosts : ghosts;
      fruit : int option }

val from_file : string -> world

val value_of_world : world -> 'a GccTypes.value

val direction_of_int : int -> direction option

val pill_count : world -> int
